'use strict';

document.addEventListener('DOMContentLoaded', function onLoaded() {
  loadOptions(function onOptionsLoaded(options) {
    host.value = options.host;
    portStart.value = options.portStart;
    portCount.value = options.portCount;
    setDefaultCheck(options.portChecked);

    moniterPorts(options);

    launch.addEventListener('click', onLaunchClicked, false);
    host.addEventListener('input', onInputChanged);
    portStart.addEventListener('input', onInputChanged);
    portCount.addEventListener('input', onInputChanged);
  });
}, false);

function onLaunchClicked() {
  error.style.display = 'none';

  const settings = {
    host: host.value,
    portStart: Number(portStart.value),
    portCount: Number(portCount.value),
    portChecked: Number(getCheckedPort()),
  };
  launchDevTools(settings)
    .catch(err => {
      error.innerHTML = `Could not launch debugger<br>${err.message}`;
      error.style.display = 'block';
    });
  storeOptions(settings, null);
}

function onInputChanged() {
  error.style.display = 'none';

  const settings = {
    host: host.value,
    portStart: Number(portStart.value),
    portCount: Number(portCount.value),
    portChecked: 0,
  };
  storeOptions(settings, null);
  moniterPorts(settings);
}